#version 430 core
layout (location = 0) in vec3 aPos;
layout (location = 1) in vec3 aNormal;
layout (location = 2) in vec2 aTexCoords;

out vec2 TexCoords;

out VS_OUT {
    vec3 FragPos;
    vec3 Normal;
    vec2 TexCoords;
    vec4 FragPosLightSpace;
	vec3 lightDir;

} vs_out;

uniform mat4 projection;
uniform mat4 view;
uniform mat4 model;
uniform mat4 lightSpaceMatrix;

uniform vec3 camFront;
uniform bool secondRun;
uniform vec3 lightPos;


void main()
{
	
	vec3 pos = aPos;
	if(secondRun){
		pos *= 2.0;
	}
	
	vs_out.FragPos = vec3(model * vec4(pos, 1.0));
	vs_out.lightDir = normalize(lightPos - vec3(model * vec4(pos, 1.0)));
    vs_out.Normal = transpose(inverse(mat3(model))) * aNormal;
    vs_out.TexCoords = aTexCoords;
    vs_out.FragPosLightSpace = lightSpaceMatrix * vec4(vs_out.FragPos, 1.0);
    gl_Position = projection * view * model * vec4(aPos, 1.0);
}